#line 1 "D:/EPD/DH Files/Mikro C programs/SD Card/SD Card on 18F452/MyProject.c"



sfr sbit Mmc_Chip_Select at RB2_bit;
sfr sbit Mmc_Chip_Select_Direction at TRISB2_bit;

unsigned char filename[] = "Temp.TXT";
unsigned char error;
unsigned char i;
unsigned int adc_value;
unsigned char Temperature_Log[ 15 ];

void main()
{
 unsigned char ones,tens,hundreds;
 unsigned int temp;

 TRISD = 0x00;
 Delay_ms(1000);

 ADCON0 = 0b10000001;
 ADCON1 = 0b11000000;
 ADC_Init();

 SPI1_Init();
 SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV64, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);
 Delay_us(10);

 error = MMC_Init();
 while(error == 1)
 {
 error = MMC_Init();
 }

 Delay_ms(1000);

 MMC_Fat_Init();
 SPI1_Init_Advanced(_SPI_MASTER_OSC_DIV4, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_LOW_2_HIGH);

 Mmc_Fat_Delete();
 Mmc_Fat_Assign(&filename,0xA0);


 while(1)
 {
 adc_value = ADC_Read(0);
 adc_value = adc_value*488;
 adc_value = adc_value/10;

 temp = adc_value/100;

 Temperature_Log[0] = 'T';
 Temperature_Log[1] = 'E';
 Temperature_Log[2] = 'M';
 Temperature_Log[3] = 'P';
 Temperature_Log[4] = '=';

 ones = temp%10;
 temp = temp/10;
 tens = temp%10;
 temp = temp/10;
 hundreds = temp%10;

 ones = ones|0x30;
 tens = tens|0x30;
 hundreds = hundreds|0x30;

 Temperature_Log[5] = hundreds;
 Temperature_Log[6] = tens;
 Temperature_Log[7] = ones;
 Temperature_Log[8] = '.';

 ones = adc_value%10;
 adc_value = adc_value/10;
 tens = adc_value%10;
 ones = ones|0x30;
 tens = tens|0x30;

 Temperature_Log[9] = tens;
 Temperature_Log[10] = ones;
 Temperature_Log[11] = ' ';
 Temperature_Log[12] = 'C';
 Temperature_Log[13] = '\r';
 Temperature_Log[14] = '\n';

 Mmc_Fat_Append();
 Mmc_Fat_Write(Temperature_Log,15);
 Delay_ms(300);
 }
}
